package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.entity.TabEvaluateQuick;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface TabEvaluateQuickMapper {
    /**
     * 根据主键删除
     *
     * @param evaluateQuickId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(String evaluateQuickId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabEvaluateQuick record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabEvaluateQuick record);

    /**
     * 根据主键查询
     *
     * @param evaluateQuickId 主键
     * @return 实体对象
     */
    TabEvaluateQuick selectByPrimaryKey(String evaluateQuickId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabEvaluateQuick record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabEvaluateQuick record);

    void delByEnterpriseId(@Param("enterpriseId") Integer enterpriseId, @Param("quickReplyType") Integer quickReplyType);

    void insertSelectiveByNotExist(TabEvaluateQuick tabEvaluateQuick);

    void updateStatusByEvaluateQuicks(@Param("enterpriseId") Integer enterpriseId, @Param("evaluateQuick") List<String> evaluateQuick, @Param("quickReplyType") Integer quickReplyType);

    List<TabEvaluateQuick> listEvaluateQuick(@Param("enterpriseId") Integer enterpriseId, @Param("quickReplyType") Integer quickReplyType);
}